%define anolis_release 1
Name:		perl-Cpanel-JSON-XS
Summary:	JSON::XS for Cpanel, fast and correct serializing
Version:	4.39
Release:	%{anolis_release}%{?dist}
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Cpanel-JSON-XS
Source0:	https://cpan.metacpan.org/authors/id/R/RU/RURBAN/Cpanel-JSON-XS-%{version}.tar.gz
Patch0:		Cpanel-JSON-XS-4.20-signature.patch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(Config)
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
BuildRequires:	perl(CBOR::XS)
BuildRequires:	perl(Compress::LZF)
BuildRequires:	perl(Convert::Bencode)
BuildRequires:	perl(CPAN::Meta::YAML)
BuildRequires:	perl(Data::Dump)
BuildRequires:	perl(YAML)
BuildRequires:	perl(YAML::Syck)
BuildRequires:	perl(YAML::XS)
# Test Suite
BuildRequires:	perl(B)
BuildRequires:	perl(charnames)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Devel::Peek)
BuildRequires:	perl(Encode) >= 1.9081
BuildRequires:	perl(lib)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Test)
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Test::Simple)
BuildRequires:	perl(threads)
BuildRequires:	perl(threads::shared) >= 1.21
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(utf8)
# Optional Tests
# Cycle: perl-Cpanel-JSON-XS → perl-Test-LeakTrace → perl-Module-Install
# → perl-YAML-Tiny → perl-JSON-MaybeXS → perl-Cpanel-JSON-XS
# Cycle: perl-Cpanel-JSON-XS → perl-Perl-MinimumVersion → perl-PPI
# → perl-List-MoreUtils → perl-Test-LeakTrace → perl-Module-Install
# → perl-YAML-Tiny → perl-JSON-MaybeXS → perl-Cpanel-JSON-XS
# Cycle: perl-Cpanel-JSON-XS → perl-Test-MinimumVerion → perl-YAML-Tiny
# → perl-JSON-MaybeXS → perl-Cpanel-JSON-XS
# Cycle: perl-Cpanel-JSON-XS → perl-Test-Kwalitee → perl-Module-CPANTS-Analyse
# → perl-JSON-MaybeXS → perl-Cpanel-JSON-XS
%if !%{defined perl_bootstrap}
BuildRequires:	perl(common::sense) >= 3.5
BuildRequires:	perl(Hash::Util)
BuildRequires:	perl(JSON) >= 2.09
BuildRequires:	perl(JSON::PP) >= 2.09
BuildRequires:	perl(JSON::XS)
BuildRequires:	perl(Math::BigFloat) >= 1.16
BuildRequires:	perl(Math::BigInt)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Tie::IxHash)
BuildRequires:	perl(Time::Piece)
%endif
# Runtime
Requires:	perl(Carp)
Requires:	perl(overload)
Requires:	perl(Scalar::Util)
Suggests:	perl(CBOR::XS)
Recommends:	perl(Math::BigFloat) >= 1.16
Recommends:	perl(Math::BigInt)
Suggests:	perl(Bencode)
Suggests:	perl(Compress::LZF)
Suggests:	perl(CPAN::Meta::YAML)
Suggests:	perl(Data::Dump)
Suggests:	perl(Data::Dumper)
Suggests:	perl(Sereal::Decoder)
Suggests:	perl(Sereal::Encoder)
Suggests:	perl(YAML)
Suggests:	perl(YAML::Syck)
Suggests:	perl(YAML::XS)

# Avoid unwanted provides and dependencies
%{?perl_default_filter}

%description
This module converts Perl data structures to JSON and vice versa. Its
primary goal is to be correct and its secondary goal is to be fast. To
reach the latter goal it was written in C.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
Buildarch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p0 -n Cpanel-JSON-XS-%{version}

# Fix shellbangs
perl -pi -e 's|^#!/opt/bin/perl|#!/usr/bin/perl|' eg/*

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
%make_build

%install
make pure_install DESTDIR=%{buildroot}
%{_fixperms} -c %{buildroot}

%check
%if !%{defined perl_bootstrap}
make test xtest AUTHOR_TESTING=1
%else
make test
%endif

%files
%license COPYING
%doc eg/
%{_bindir}/cpanel_json_xs
%{perl_vendorarch}/auto/Cpanel/
%{perl_vendorarch}/Cpanel/
%{_mandir}/man1/cpanel_json_xs.1*
%{_mandir}/man3/Cpanel::JSON::XS.3*
%{_mandir}/man3/Cpanel::JSON::XS::Boolean.3*
%{_mandir}/man3/Cpanel::JSON::XS::Type.3*

%files doc
%doc Changes README

%changelog
* Fri Jan 17 2025 yangxinyu <yangxinyu@nfschina.com> - 4.39-1
- update to 4.39
-fix cve-2022-48623

* Wed Feb 8 2023 Funda Wang <fundawang@yeah.net> - 4.32-2
- Rebuild without perl_bootstrap

* Mon Feb 6 2023 Funda Wang <fundawang@yeah.net> - 4.32-1
- Import package for anolis 23
